<template>
  <rui-form :loading="loading"
            :errors="errors"
            :disable-submit="interactionExists"
            model="resource_interaction"
            @cancel="$emit('cancel')"
            @submit.prevent="save">
    <rui-field input-id="resource_interaction_subject" :label="$t('activerecord.attributes.resource_interaction.subject')">
      <multiselect id="resource_interaction_subject"
                   v-model="subjectInput"
                   :options="selectableSubjects"
                   :allow-empty="false"
                   track-by="id"
                   label="name" />
    </rui-field>

    <rui-field input-id="resource_interaction_target"
               :label="$t('activerecord.attributes.resource_interaction.target')"
               :error="interactionExists ? $t('js.resource_interaction.form.interaction_pair_exists') : null">
      <multiselect id="resource_interaction_target"
                   v-model="targetInput"
                   :options="availableTargets"
                   :allow-empty="false"
                   track-by="id"
                   label="name" />
    </rui-field>

    <rui-field input-id="resource_interaction_nature" :label="$t('activerecord.attributes.resource_interaction.nature')">
      <select id="resource_interaction_nature" v-model="inputs.nature" name="nature" required>
        <option v-for="nature in natures" :key="nature" :value="nature">
          {{ $t(`activerecord.attributes.resource_interaction/nature.${nature}`) }}
        </option>
      </select>
    </rui-field>

    <rui-accordion :caption="$t('js.resource_interaction.form.nature_help')">
      <gpa-resource-interactions-help-table />
    </rui-accordion>

    <rui-field input-id="resource_interaction_notes" :label="$t('activerecord.attributes.resource_interaction.notes')">
      <input id="resource_interaction_notes" v-model="inputs.notes" type="text" name="notes">
    </rui-field>

    <rui-field input-id="resource_interaction_sources" :label="$t('activerecord.attributes.resource_interaction.sources')">
      <textarea id="resource_interaction_sources" v-model="inputs.sources" name="sources" />
    </rui-field>
  </rui-form>
</template>

<script>
import RuiAccordion from '@experiments-labs/rise_ui/src/components/DataDisplay/Accordion/Accordion.vue'
import RuiField from '@experiments-labs/rise_ui/src/components/Form/Field.vue'
import RuiForm from '@experiments-labs/rise_ui/src/components/Form/Form.vue'

import ResourceInteraction, { NATURE_KEYS as natures } from '../../../../classes/models/ResourceInteraction'
import Toaster from '../../../../tools/Toaster'
import Multiselect from 'vue-multiselect'
import GpaResourceInteractionsHelpTable from './_HelpTable.vue'

export default {
  name: 'GpaResourceInteractionsForm',
  emits: [
    'cancel',
    'saved',
  ],
  components: { RuiAccordion, RuiField, RuiForm, GpaResourceInteractionsHelpTable, Multiselect },
  props: {
    resourceInteraction: { required: false, type: ResourceInteraction, default: null },
    subjectId: { required: false, type: Number, default: null },
  },
  data () {
    return {
      inputs: this.makeInputs(),
      // Vue-multiselect values
      subjectInput: this.initializeSubject(),
      targetInput: this.initializeTarget(),
      natures,
      errors: null,
      loading: false,
    }
  },
  computed: {
    selectableSubjects () { return this.$store.getters.resourceInteractionsGroups },
    availableTargets () {
      if (!this.subjectInput) return this.selectableSubjects

      return this.selectableSubjects.filter(r => r.id !== this.subjectInput.id)
    },
    interactionExists () {
      if (!this.subjectInput || !this.targetInput) return false

      const resourceInteractions = this.$store.getters.resourceInteractions
      for (let i = 0, amount = resourceInteractions.length; i < amount; i++) {
        if (this.resourceInteraction && this.resourceInteraction.id === resourceInteractions[i].id) continue
        if (
          (resourceInteractions[i].subjectId === this.subjectInput.id && resourceInteractions[i].targetId === this.targetInput.id)
          || (resourceInteractions[i].subjectId === this.targetInput.id && resourceInteractions[i].targetId === this.subjectInput.id)
        ) return true
      }

      return false
    },
  },
  methods: {
    initializeSubject () {
      let resourceInteractionsGroup
      if (this.$props.resourceInteraction && this.$props.resourceInteraction.subjectId) {
        resourceInteractionsGroup = this.$props.resourceInteraction.subject
      } else if (this.$props.subjectId) {
        resourceInteractionsGroup = this.$store.getters.resourceInteractionsGroup(this.$props.subjectId)
      }

      if (resourceInteractionsGroup) return { id: resourceInteractionsGroup.id, name: resourceInteractionsGroup.name }

      return null
    },
    initializeTarget () {
      if (this.$props.resourceInteraction && this.$props.resourceInteraction.targetId) {
        const resourceInteractionsGroup = this.$props.resourceInteraction.target
        return { id: resourceInteractionsGroup.id, name: resourceInteractionsGroup.name }
      }
      return null
    },
    makeInputs () {
      let inputs
      if (this.resourceInteraction) {
        inputs = {
          id: this.resourceInteraction.id,
          nature: this.resourceInteraction.nature,
          notes: this.resourceInteraction.notes,
          sources: this.resourceInteraction.sources,
        }
      } else {
        inputs = {
          id: null,
          nature: null,
          notes: null,
          sources: null,
        }
      }

      return inputs
    },
    save () {
      const payload = { ...this.inputs }
      payload.subject_id = this.subjectInput.id
      payload.target_id = this.targetInput.id
      this.loading = true
      this.$store.dispatch('saveResourceInteraction', payload)
        .then(() => {
          Toaster.success(this.$t('js.resource_interaction.form.successfully_saved'))
          this.$emit('saved')
        })
        .catch((error) => { this.errors = error })
        .then(() => { this.loading = false })
    },
  },
  watch: {
    resourceInteraction () {
      this.inputs = this.makeInputs()
      // Reset values for vue-multiselect
      this.subjectInput = this.initializeSubject()
      this.targetInput = this.initializeTarget()
    },
    subjectId () {
      this.subjectInput = this.initializeSubject()
    },
  },
}
</script>
